package com.chinaitop.depot.pushs.service.impl;



import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.alibaba.fastjson.JSON;
import com.chinaitop.depot.pushs.service.PushsService;
import com.chinaitop.depot.storage.mapper.StorageChangeStoragehouseDefaultMapper;
import com.chinaitop.depot.storage.mapper.StorageChangeStoragehouseRopMapper;
import com.chinaitop.depot.storage.model.StorageChangeStoragehouseDefault;
import com.chinaitop.depot.storage.model.StorageChangeStoragehouseDefaultExample;
import com.chinaitop.depot.storage.model.StorageChangeStoragehouseDefaultExample.Criteria;
import com.chinaitop.depot.storage.service.SystemOutsideDataService;
import com.chinaitop.depot.storage.model.StorageChangeStoragehouseRop;
import com.chinaitop.depot.storage.model.StorageChangeStoragehouseRopExample;
import com.chinaitop.depot.storage.utils.ParameterUtil;
import com.chinaitop.depot.unissoft.model.ResponseEntity;

@Service
public class PushServiceImpl implements PushsService{

    final static Logger logger  =  LoggerFactory.getLogger(PushServiceImpl.class );

	@Resource
	private StorageChangeStoragehouseDefaultMapper storageChangeStoragehouseDefaultMapper;
	@Resource
	private StorageChangeStoragehouseRopMapper storageChangeStoragehouseRopMapper;
	@Resource 
	private SystemOutsideDataService systemOutsideDataService;

	@Transactional(rollbackFor = Exception.class)
	@Override
	public String getChangeDatas(String orgId, String ids) {
		//查出数据
		Map<String,Object> mapCondition = new HashMap<String, Object>();
		if(ParameterUtil.isnotnull(ids)){
			List<String> conList = Arrays.asList(ids.split(","));
			mapCondition.put("ids",conList);
		}
		if(ParameterUtil.isnotnull(orgId)){
			mapCondition.put("orgId",orgId);
		}
		List<Map<String,Object>> mainList =storageChangeStoragehouseDefaultMapper.contractData(mapCondition);

		Map<String,Object> mapData = new HashMap<String, Object>();
		mapData.put("status", "success");
		mapData.put("mainData", mainList);
		return JSON.toJSONString(ResponseEntity.ok(mapData));
	}

	@Transactional(rollbackFor = Exception.class)
	@Override
	public String updateChangeStorageHouse(String orgId, String applyNo, String foodStatus, String goalNumber) {
		String retS = "Success";
		StringBuffer sbf = new StringBuffer(50);
		sbf.append("orgId="+orgId).append("&applyNo="+applyNo).append("&foodStatus="+foodStatus).append("&goalNumber="+goalNumber);

		try {
			StorageChangeStoragehouseDefaultExample StorageChangeStoragehouseDefaultExample = new StorageChangeStoragehouseDefaultExample();
			Criteria Criteria = StorageChangeStoragehouseDefaultExample.createCriteria();
			Criteria.andOrgIdEqualTo(Integer.parseInt(orgId));
			//Criteria.andApplyNoEqualTo(applyNo);
			Criteria.andChangehouseNoEqualTo(applyNo);
			List<StorageChangeStoragehouseDefault> list = storageChangeStoragehouseDefaultMapper.selectByExample(StorageChangeStoragehouseDefaultExample);
			if(list == null || list.size() ==0 ) {
				retS = "该数据不存在!";
				systemOutsideDataService.addlogger("dcjdsjjs", sbf.toString(), retS);
				return retS;
			}else {
				StorageChangeStoragehouseDefault o = list.get(0);
				
				StorageChangeStoragehouseRop StorageChangeStoragehouseRop = new StorageChangeStoragehouseRop();
				StorageChangeStoragehouseRop = new StorageChangeStoragehouseRop();
				StorageChangeStoragehouseRop.setApplyFirm(o.getApplyFirm());   //申请倒仓企业
				StorageChangeStoragehouseRop.setChangehouseNo(applyNo);  //倒仓通知单编号
				StorageChangeStoragehouseRop.setApplyTime(o.getApplyTime());   //申请日期
				StorageChangeStoragehouseRop.setOutStorehouse(o.getOutStorehouse());  //倒出仓房
				StorageChangeStoragehouseRop.setOutStorehouseName(o.getOutStorehouseName());   //倒出仓房名称
				StorageChangeStoragehouseRop.setOutWarehouse(o.getOutWarehouse());     //倒出货位
				StorageChangeStoragehouseRop.setOutWarehouseName(o.getOutWarehouseName());  //倒出货位名称
				StorageChangeStoragehouseRop.setFoodWar(o.getFoodWar());   //粮食品种
				StorageChangeStoragehouseRop.setFoodStatus(foodStatus);  //完成状态
				StorageChangeStoragehouseRop.setFoodNature(o.getFoodNature());   //粮食性质
				StorageChangeStoragehouseRop.setBitWeigh(o.getBitWeigh());   //是否称重
				StorageChangeStoragehouseRop.setOutBefore(o.getOutBefore());  //倒出前保存方式
				StorageChangeStoragehouseRop.setCreateTime(o.getCreateTime());  //接收日期
				StorageChangeStoragehouseRop.setIntoStorehouse(o.getIntoStorehouse());  //倒入仓房
				StorageChangeStoragehouseRop.setIntoStorehouseName(o.getIntoStorehouseName());   //倒入仓房名称
				StorageChangeStoragehouseRop.setIntoWarehouse(o.getIntoWarehouse());  //倒入货位
				StorageChangeStoragehouseRop.setIntoWarehouseName(o.getIntoWarehouseName());   //倒入货位名称
				StorageChangeStoragehouseRop.setDetailWar(o.getDetailWar());   //明细品种
				StorageChangeStoragehouseRop.setFoodNumber(goalNumber);   //完成数量(公斤)
				StorageChangeStoragehouseRop.setGoalNumber(o.getFoodNumber());   //目标数量
				StorageChangeStoragehouseRop.setOutAfter(o.getOutAfter());  //倒出后保管方式
				StorageChangeStoragehouseRop.setOrgId(Integer.parseInt(orgId));   //单位ID
				StorageChangeStoragehouseRop.setApplyNo(o.getApplyNo());  //申请单号

				StorageChangeStoragehouseRopExample StorageChangeStoragehouseRopExample = new StorageChangeStoragehouseRopExample();
				StorageChangeStoragehouseRopExample.Criteria criteria = StorageChangeStoragehouseRopExample.createCriteria();
				criteria.andOrgIdEqualTo(Integer.parseInt(orgId));
				criteria.andChangehouseNoEqualTo(applyNo);
				List<StorageChangeStoragehouseRop> ropList = storageChangeStoragehouseRopMapper.selectByExample(StorageChangeStoragehouseRopExample);
				if(ropList == null || ropList.size() ==0 ){
					storageChangeStoragehouseRopMapper.insertSelective(StorageChangeStoragehouseRop);
				}else{
					storageChangeStoragehouseRopMapper.updateByPrimaryKeySelective(StorageChangeStoragehouseRop);
				}
			}
			systemOutsideDataService.addlogger("dcjdsjjs", sbf.toString(), retS);
		} catch (Exception e) {
			retS = "系统异常，请联系管理员";
			systemOutsideDataService.addlogger("dcjdsjjs", sbf.toString(), retS);
			e.printStackTrace();
		}
		return retS;
	}

}
